var WIDGETVERSION = 1.2; // the version number of the currently used widget

function getWidgetversion() {
	$('#version').text(WIDGETVERSION); // display version number
	$('#connectionmsg').hide(); // (potentially) hide message from previous try
	// load the changelog, that might show newer verions
	$.ajax({
		type:'GET',
	    url: 'http://files.myopera.com/Dodo87/pwchecker/versions.xml',
	    success: handleWidgetversion,
	    error: errorWidgetversion,
	    dataType: "xml"
  	});
}

function errorWidgetversion(XMLHttpRequest, textStatus, errorThrown) {
		// Loading failed.
	   	$('#connectionmsg').show();
}

function handleWidgetversion(xml, textStatus, XMLHttpRequest) {
	var vinfo = $('#changelog');

	if($('versions',xml).length != 1) {
 			// not connected to a vpn where i had to, i got html code as result.
 			// so this tests, if an element 'widgetversion' exists
 			// i.e. the result is not as expected.
			$('#connectionmsg').show();
  	} else {
  		// first create changelog
  		var newest = WIDGETVERSION;
  		$('version',xml).each(function() {

			if(($(this).attr('v') > newest) && !($(this).attr('published') == 'no')) {
  				newest = parseFloat($(this).attr('v'));
  			}

  			var ul = $('<ul />');
  			$(this).children('change').each(function() {
  				ul.append( $('<li class="'+$(this).attr('type')+'">'+$(this).text()+'</li>') );
  			});
  			if($(this).attr('date')) {
  				notpub = '<p class="pubdate">'+$(this).attr('date')+'</p>';
  			} else if($(this).attr('published') == 'no') {
  				notpub = '<p class="pubdate">not published</p>';
  			} else {
  				notpub = '';
  			}


  			vinfo.append('<h4>Version '+$(this).attr('v')+'</h4>').append(notpub).append(ul);
  		});

  		$('#latestversion').text(newest.toString());

  		// check the widget version for being up-to-date and for being compatible
	  	if(parseFloat($('versions',xml).attr('compatible')) <= WIDGETVERSION) {
  			// but still test for newer version
	  		if(newest > WIDGETVERSION) {
	  			widget.showNotification('New widget version available on widgets.opera.com.');
	  			$('#newerversionmsg').show();
	  		}
	  	} else {
	  		// widget cannot be used any more. show message and do not go on.
	  		$('#incompatibleversionmsg').show();
	  	}
	}
}